@import '../utilities/functions.sass'

$black:        hsl(0, 0%, 4%) !default
$black-bis:    hsl(0, 0%, 7%) !default
$black-ter:    hsl(0, 0%, 14%) !default

$text: $black-bis !default

// primary
$red: #c20000;
$black: #000000;
$white: #ffffff;
$blue-grey: #4c626c;
$sea: #152773;
$blueberry: #572381;
$sky: #005aa3;
$lime: #a4b123;
$tangerine: #e9600e;

$success: #018701;

$red-lighten: ();
$red-darken: ();
$black-lighten: ();
$blue-grey-lighten: ();
$blue-grey-darken: ();
$sea-lighten: ();
$sea-darken: ();
$blueberry-lighten: ();
$blueberry-darken: ();
$sky-lighten: ();
$sky-darken: ();
$lime-lighten: ();
$lime-darken: ();
$tangerine-lighten: ();
$tangerine-darken: ();
$success-lighten: ();
$success-darken: ();

@for $i from 1 through 5

  $red-lighten: append($red-lighten, tint($red, $i * 19%))
  $red-darken: append($red-darken, shade($red, $i * 10%))

  $black-lighten: append($black-lighten, tint($black, $i * 19%))

  $blue-grey-lighten: append($blue-grey-lighten, tint($blue-grey, $i * 19%))
  $blue-grey-darken: append($blue-grey-darken, shade($blue-grey, $i * 10%))

  $sea-lighten: append($sea-lighten, tint($sea, $i * 19%))
  $sea-darken: append($sea-darken, shade($sea, $i * 10%))

  $blueberry-lighten: append($blueberry-lighten, tint($blueberry, $i * 19%))
  $blueberry-darken: append($blueberry-darken, shade($blueberry, $i * 10%))

  $sky-lighten: append($sky-lighten, tint($sky, $i * 19%))
  $sky-darken: append($sky-darken, shade($sky, $i * 10%))

  $lime-lighten: append($lime-lighten, tint($lime, $i * 19%))
  $lime-darken: append($lime-darken, shade($lime, $i * 10%))

  $tangerine-lighten: append($tangerine-lighten, tint($tangerine, $i * 19%))
  $tangerine-darken: append($tangerine-darken, shade($tangerine, $i * 10%))

  $success-lighten: append($success-lighten, tint($success, $i * 19%))
  $success-darken: append($success-darken, shade($success, $i * 10%))

$brand-colors: ( primary: $red, secondary: $blue-grey, info: $sky, success: $success, warning: $tangerine, danger: nth($red-lighten, 1), red: $red, black: $black, white: $white, blue-grey: $blue-grey, sea: $sea, blueberry: $blueberry, sky: $sky, lime: $lime, tangerine: $tangerine, text-black: $text );

@each $key, $val in $brand-colors

  .has-bg-#{$key}
    background-color: $val !important

    &.has-smartColor
      color: findColorInvert($val)

      @for $i from 1 through 5
        &.lighten-#{$i}
          color: findColorInvert(tint($val, $i * 19%))
        
        &.darken-#{$i}
          color: findColorInvert(shade($val, $i * 10%))

    @for $i from 1 through 5
      &.lighten-#{$i}
        background-color: tint($val, $i * 19%) !important
      
      &.darken-#{$i}
        background-color: shade($val, $i * 10%) !important

  .has-text-#{$key}
    color: $val !important

    @for $i from 1 through 5
      &.text--lighten-#{$i}
        color: tint($val, $i * 19%) !important
      
      &.text--darken-#{$i}
        color: shade($val, $i * 10%) !important

  .has-bg-white
    background-color: #fff

  *[dark], .has-text-white
    color: white !important

.transparent
  background-color: transparent !important